import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;

public class set_min_max_ex2 implements PlugIn {

	public void run(String arg) {
		GenericDialog gd=new GenericDialog("Options"); //here we construct the dialog
		float min=0.0f;
		gd.addNumericField("Minimum Value",min,3); /*this method calls for a label, a default value, and then 
		the number of decimal places*/
		float max=10.0f;
		gd.addNumericField("Maximum Value",max,3);
		boolean newimage=false;
		gd.addCheckbox("Create New Image?",newimage); //again, label, then default value
		gd.showDialog(); //show the dialog box
		if(gd.wasCanceled()){return;} //see if it was cancelled (return exits the plugin)
		min=(float)gd.getNextNumber(); //find out what was chosen by the user
		max=(float)gd.getNextNumber();
		newimage=gd.getNextBoolean();
		ImagePlus imp=WindowManager.getCurrentImage();
		int width=imp.getWidth();
		int height=imp.getHeight();
		ImageProcessor ip=imp.getProcessor();
		float[] pixels=(float[])ip.getPixels();
		float[] newpixels=new float[width*height];
		if(newimage){
			System.arraycopy(pixels,0,newpixels,0,width*height);
			for(int i=0;i<width*height;i++){
				if(newpixels[i]>max){
					newpixels[i]=max;
				}
				else{
					if(newpixels[i]<min){
						newpixels[i]=min;
					}
				}
			}
			ImageProcessor ip2=new FloatProcessor(width,height,newpixels,null);
			ImagePlus imp2=new ImagePlus("Min_Max_Image",ip2);
			imp2.show();
		} else {
			for(int i=0;i<width*height;i++){
				if(pixels[i]>max){
					pixels[i]=max;
				}
				else{
					if(pixels[i]<min){
						pixels[i]=min;
					}
				}
			}
			imp.updateAndDraw();
		}
	}

}
